/*
 * Copyright 1999-2017 Alibaba Group Holding Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.alibaba.polardbx.druid.bvt.sql.mysql.select;

import com.alibaba.polardbx.druid.sql.MysqlTest;
import com.alibaba.polardbx.druid.sql.ast.SQLStatement;
import com.alibaba.polardbx.druid.sql.ast.expr.SQLIdentifierExpr;
import com.alibaba.polardbx.druid.sql.dialect.mysql.parser.MySqlStatementParser;
import com.alibaba.polardbx.druid.sql.dialect.mysql.visitor.MySqlASTVisitorAdapter;
import com.alibaba.polardbx.druid.sql.visitor.SQLASTVisitor;

import java.util.List;


public class MySqlSelectTest_226 extends MysqlTest {

    public void test_0() throws Exception {
        String sql = "SELECT sum(`price`) AS aggregate, `aa` \n" +
                "FROM `na_orders`\n" +
                "WHERE `updated_at` > '2018-12-03 00:00:00'\n" +
                "    AND `pay_status` = 1\n" +
                "    AND 0 = 1\n" +
                "ORDER BY 1";

//        System.out.println(sql);

        MySqlStatementParser parser = new MySqlStatementParser(sql);
        List<SQLStatement> statementList = parser.parseStatementList();

        assertEquals(1, statementList.size());

        SQLStatement stmt = statementList.get(0);

        SQLASTVisitor v = new MySqlASTVisitorAdapter() {
            public boolean visit(SQLIdentifierExpr x) {
                System.out.println(x.getName());
                return true;
            }
        };
        stmt.accept(v);

//        assertEquals("SELECT userid, order, unionid\n" +
//                "FROM t", stmt.toString());
//
//        assertEquals("select userid, order, unionid\n" +
//                "from t", stmt.clone().toLowerCaseString());
    }
}